var GameScene = cc.Scene.extend({

    config : null,
    updateView : null,
    updateMgr : null,
    sdkInterface : null,
    _startBg : null,  

    ctor:function()
    {  
        this._super();

        var size = cc.winSize;
        this._startBg = new cc.Sprite("res/GameBg.jpg");
        this._startBg.attr({
            x: size.width / 2,
            y: size.height / 2
        });
        this.addChild(this._startBg, 0);

        this.updateView = new UpdateView();
        this.updateView.setTips("帅气男神团闪亮登场！！");
        this.addChild(this.updateView);  

        this.config = new GameConfig();
 
        if(cc.sys.isNative && kyGame.config["isRuntime"] != true) {
            var className = "",
                sdkId = 0,
                en = jsb.reflection;
            //获取SDKID
            if(this.config.isAndroid()) {
                className = "org/cocos2dx/javascript/AppActivity";
                sdkId = parseInt( en.callStaticMethod(className, "getSDKID", "()Ljava/lang/String;" ) );
            }
            else if(this.config.isIOS()) {
                className = "KYPlatform"
                sdkId = en.callStaticMethod(className, "getSDKID")
                print("#ios sdkid", sdkId)
            }

            //sdkId = 99999999;
            //判断是否要启用接口
            this.config.setSdkId(sdkId);
            if(this.config.sdkId == 0 || this.config.sdkId == 99999999) en = null;
            sdkId = sdkId || 0;

            this.updateMgr = new GameUpdate(this);
            this.sdkInterface = new BaseInterface(this, en, className);
            if( sdkId == 0 || sdkId == 99999999 ) { 
                this.startUpdate();
            }
            else {
                // 先初始化SDK, 调用初始化, 再更新
                this.sdkInterface.setCallback();
                this.sdkInterface.luaCall([this.sdkInterface.initSdk]);
            }
        }
        else {

            this.enterGame();
        }
    },
    startUpdate : function() {
        //检测更新
        this.updateMgr.checkUpdate();
    },
    getStartBg:function()
    {
        return this._startBg;
    },

    enterGame:function()
    {

        if(cc.sys.isNative && kyGame.config["isRuntime"] != true) {
            //TODO: require js?? cc.game.config.coreJs
            var this_ = this;
            cc.loader.loadJs(cc.game.config.jsList, function(){
                new GameStart(this_);
            });
        }
        else {
            new GameStart(this);
        }
    },

});

var GameUpdate = cc.Class.extend({
    gameScene : null,
    config : null,
    _packKey : "PACKET_DOWNLOAD",
    _updatePaths : null,
    _currentItem : null,
    _tryTime : 3,
    isNeedRestart : false,
    mgr : null,
    sdkid : 0, 
    _updateView : null,
    ctor : function(gameScene) {
        this.gameScene = gameScene; 
 
        this.config = gameScene.config;

        this._updateView = gameScene.updateView; 
        this.sdkid = parseInt(this.config.sdkId) ; 

        this.isNeedRestart = false ;

        this._packKey = "PACKET_DOWNLOAD" ;
        this._updatePaths = [];
        this._updateCount = 0;
        this._currentItem = null;
        this._tryTime = 3;

        this.initFunc();
    },
    initFunc : function() {
        var percentPast = -1,
            this_ = this;
        function redownload() {
            if(this_._tryTime > 0) {
                this_._tryTime--;
                this_.config.writeKV( this_._packKey, "" );
                this_._updatePaths.unshift(this_._currentItem);
                this_.updateNext();
            }
        }
        function error(tag, errorCode) {
            print("#error", errorCode);
            switch(errorCode) {
                case 0:     //创建文件失败,直接提示
                    redownload();
                    break;
                case 1:     //网络问题 提示，并且重新下载
                    redownload();
                    break;
                case 2:     //没有新版本
                    this_.updateComplete();
                    break;
                case 3:
                    redownload();
                    break;
            }
        } 
        function progress(tag, percent) { 
            percent = Math.ceil(  percent * 90 / 100 );
            if( percent != percentPast ) {
                this_._updateView.setProgress( percent );
                this_._updateView.setTips( "真心英雄们正在努力下载更新包{0}({1}/{2}),进度为{3}%...".format( 
                    this_._currentItem.p, this_._updateCount - this_._updatePaths.length, this_._updateCount, percent ) );
                percentPast = percent;
            }
        } 
        // status: 1:全部完成, 2:全部开始, 3:单个开始, 4:单个结束, 5:解压开始, 6:解压结束
        function success(tag, status, val) {
            switch(status) {
                case 4:
                    this_.config.writeKV( this_._packKey, this_._currentItem.v.toString() );
                    this_.mgr.uncompress();
                    break;
                case 5:
                    this_._updateView.setTips( "真心英雄们正在拼命安装游戏{0}({1}/{2})...".format(
                        this_._currentItem.p, this_._updateCount - this_._updatePaths.length, this_._updateCount) )
                    break;
                case 6:
                    // 删除下载的文件?
                    this_.mgr.removeDownloadPacket();
                    kyGame.config["resVersion"] = this_._currentItem.v.toString();
                    this_.config.writeKV(this_._packKey, ""); //清掉下载版本号
                    this_.updateNext();
                    break;
            }
        } 

        this.mgr = cc.AssetsUpdateMgr.create(error, progress, success) ;
        this.mgr.removeDownloadPacket() 

    },
    checkUpdate : function() {
        // this.updateComplete();

        var this_ = this;

        function requestVersionCallback(errInfo, datas) {
            print("#version.txt:", datas);
            if(typeof(datas) != "undefined")
            {
                var vals = datas.split("\r\n");
                // 排序
                var codes = [], 
                    passVer = parseInt(kyGame.config["resVersion"]),
                    currentVer = 0;
                for(var i = 0; i < vals.length; i++) {
                    var t = vals[i].substring(0, 1); 
                    if( t == "c" || t == "d" || t == "f" || t == "u" ) {
                        currentVer = parseInt(vals[i].substr(1)); 
                        if(currentVer > passVer) {
                            codes.push( { v : currentVer, p : vals[i] } );
                        }
                    }
                    else if(t == "v") {
                        var vers = vals[i].split(",");
                        for(var j = 0; j < vers.length; j++) {
                            currentVer = parseInt(vers[j].substr(1))
                            if(currentVer > passVer) {
                                codes.push( { v : currentVer, p : vers[j] } );
                            }
                        }
                    }
                }
     
                codes.sort(function(a, b) {
                    return a.v - b.v;
                });

                this_._updatePaths = codes;
                this_._updateCount = this_._updatePaths.length;

                if(this_._updateCount > 0) {
                    print("#start update", this_._updatePaths.length);
                    this_.updateNext();
                }
                else {
                    print("#没有版本更新");
                    this_.updateComplete();
                }
            }
            else
            {
                print("#没有版本更新");
                this_.updateComplete();
            }
        } 

        function urlHandler(errInfo, datas) {
            print("#urlHandler", datas);
            if(typeof(datas) != "undefined")
            {
                var vals = datas.split("\r\n");
                var dict = {};
                if(vals.length > 0) {
                    var hasUrl = false;
                    for(var i = 0; i < vals.length; i++) {
                        var item = vals[i].split("###");
                        if(!!item && item.length == 2) {
                            dict[item[0]] = item[1];
                            hasUrl = true;
                        }
                    }
                    if(hasUrl) {
                        var url = dict[this_.sdkid.toString()];
                        if(!url) {
                            url = dict["0"];
                        }
                        if( this_.sdkid == 0 || this_.sdkid == 99999999 ) {
                            url = dict["-1"];
                        }
                        print("#version url", this_.sdkid, url);
                        if( !url ) {
                            this_.updateComplete();
                        }
                        else {
                            print("#second request", url, "version.txt");
                            // this_.config.verUrl = url;
                            kyGame.config["verUrl"] = url;
                            cc.loader.loadTxtRemote(url + "version.txt?" + Math.random(), requestVersionCallback);
                        }
                    }
                    else {
                        this_.updateComplete();
                    }
                }
                else {
                    this_.updateComplete();
                }
            }
        } 
        if(this.sdkid != 0) {
            print("#kyGame.config[\"verUrl\"]", kyGame.config["verUrl"], "url.txt")
            cc.loader.loadTxtRemote(kyGame.config["verUrl"] + "url.txt?" + Math.random(), urlHandler);
        }
        else {
            this.updateComplete();
        } 
    },
    updateNext : function() {
        if(this._updatePaths != null && this._updatePaths.length > 0) {
            this._updateView.setTips("真心英雄们正在为您做准备一场更新！！"); 
            this._currentItem = this._updatePaths.shift();
            print("#this._currentItem", this._currentItem.v, this._currentItem.p);
            var pastDownVal = this.config.readKV(this._packKey),
                pastDown = 0;
            if(pastDownVal != null && pastDownVal != "") {
                pastDown = parseInt(pastDownVal);
            }
            print("#pastDown", pastDown, this._currentItem.v);
            if(pastDown > 0 && pastDown == parseInt(this._currentItem.v)) {
                // 要下载的版本包已经在本地, 开始解压
                this.mgr.uncompress();
            }
            else {
                var downloadFile = kyGame.config["verUrl"] + this._currentItem.p + ".zip";
                print("#load", downloadFile);
                this.mgr.download( downloadFile );
            }
        }
        else {
            this.updateComplete();
            this._currentItem = null;
        } 
    },
    updateComplete : function() {
        if(this._updateView != null) {
            this._updateView.setTips("帅气男神团闪亮登场！！");
        } 
        this.gameScene.enterGame();
        // 更新完之后要不要重启
        // if self.isNeedRestart then
        //     gameRestart()
        // else
        //     this.gameScene.enterGame();
        // end
        this.dispose()
    },
    dispose : function() { 
        this.config = null;
        this.json = null;
        this._updateView = null;
        this.gameScene = null;
    }
});


//-----------------------------接口基类开始--------------------------------------------
var sdkCallback = function(dataStr) {
    cc.log("#sdkCallback", dataStr);
}

var BaseInterface = cc.Class.extend({
    _en : null,
    _className : null,
    _gameScene : null,
    _configData : null,
    _callGameFunc : null, 
    chgHostToIP : 1,
    showSDKLoginPage : 2,
    enterSNSCenter : 3,
    showTip : 4,
    showPayPage : 5,
    initSdk : 6,
    //发送数据,
    sendData : 7,
    //按下返回键,
    pressBack : 9,
    //退出游戏,
    exit : 10,
    //退出账号,
    loginOut : 11 ,
    //是否有用户中心(默认true),
    hasUserCenter : 12 ,
    //获取大版本号,
    getBigVersion : 13 ,
    //获取子频道,
    getChildChannel : 14 ,
    hasLoginOut : 15,
    confirmUserName : 16,
    getNetworkState : 17,
    getDeviceInfo : 18,
    getIOSDeviceInfo : 19,

    //回调 java回调lua参数,
    resume_call : 101,
    destroy_call : 102,
    pause_call : 103,
    startLeaving_call : 104,
    dialogOk_call : 105,
    dialogCancel_call : 106,
    initComplete_call : 107,
    //sdk登陆成功,
    sdkLoginSuccess : 108,
    //sdk登陆失败,
    sdkLoginError : 109,
    //sdk取消登陆,
    sdkLoginCancel : 110,
    //sdk付款成功,
    sdkPaySuccess : 111,
    //sdk付款取消,
    sdkPayCancel : 112,
    //帐号退出,
    logout : 113,
    ctor : function(gameScene,en,className) {
        this._gameScene = gameScene;
        this._configData = gameScene.config;
        this._en = en;
        this._className = className;
    },
    setCallGameFunc : function(func) {
        this._callGameFunc = func;
    },
    pkgParams : function(paramList) {
        if(!paramList || paramList.length == 0) return "";
        return paramList.join("#@$");
    },
    parseParams : function(str) {
        return str.split("#@$");
    },
    setCallback : function() {
        if(!this._en) return;
        var sdkCallbackFuncName = "sdkCallback";

        var this_ = this;
        sdkCallback = function(values) {
            print("#sdkCallback", values);
            var data = values
            if(this_._configData.isAndroid() || this_._configData.isIOS()) {
                data = JSON.parse(data);
            }
            var status = parseInt(data.status);
            var vals = this_.parseParams(data.vals);
            if(status == this_.initComplete_call) {
                cc.log("初始化sdk完成");
                this_._gameScene.startUpdate();
            }
            if(!!this_._callGameFunc) {
                this_._callGameFunc(status, vals);
            }
        }

        if( this._configData.isAndroid() ) {
            this._en.callStaticMethod(this._className, "setCallbackF", "(Ljava/lang/String;)Ljava/lang/String;", sdkCallbackFuncName );
        }
        else if( this._configData.isIOS() ) {
            this._en.callStaticMethod(this._className, "setCallbackF:", sdkCallbackFuncName );
        }
    },
    luaCall : function(values) {
        if(!this._en) return;
        var param = this.pkgParams(values);
        print("#luacall", values);
        if(this._configData.isAndroid()) {
            try {
                return this._en.callStaticMethod( this._className, "luaCall", "(Ljava/lang/String;)Ljava/lang/String;", param );
            } catch(e) { cc.log("#callStaticMethod error", e); }
        }
        else if(this._configData.isIOS()) {
            try {
                var retVal = this._en.callStaticMethod( this._className, "luaCall:", param );
                return retVal;
                // return this._en.callStaticMethod( this._className, "luaCall:", param );
            } catch(e) { cc.log("#callStaticMethod error", e); }
        }
        return "";
    }
});

//-----------------------------接口基类结束--------------------------------------------

var GameConfig = cc.Class.extend({
    // verUrl : "http://smjtload.jiujiuwan.com/",
    // resVersion : 1000,
    openPay : true,
    noOpenPayTip : "充值还未开放",
    sdkId : 0,//平台代理ID 

    ctor:function()
    {
    },
    setSdkId:function(sdkId)
    {
        this.sdkId = sdkId;
        //服务器状态码  0:维护, 1,推荐, 2,火爆, 3,正常, 4,新服 
    },
    isIOS:function()
    {
        return cc.sys.os === cc.sys.OS_IOS || cc.sys.os === cc.sys.OS_OSX;
    },
    isAndroid:function()
    {
        return cc.sys.os === cc.sys.OS_ANDROID;
    },
    isWin:function()
    {
        return cc.sys.os === cc.sys.OS_WINDOWS || cc.sys.os === cc.sys.OS_WP8 || cc.sys.os === cc.sys.OS_WINRT;
    },
    inSDK:function()
    {
        return this.sdkId > 0 && this.sdkId != 99999999;
    },
    writeKV : function(key, value) {
        cc.sys.localStorage.setItem(key, value);
    },
    readKV : function(key) {
        var val = cc.sys.localStorage.getItem(key);
        return val;
    }
});

var print = function() {
    var text = Array.prototype.join.call(arguments, ", ");
    cc.log(text);
}

String.prototype.format = function(args) {
    var result = this;
    if (arguments.length > 0) {    
        if (arguments.length == 1 && typeof (args) == "object") {
            for (var key in args) {
                if(args[key]!=undefined){
                    var reg = new RegExp("({" + key + "})", "g");
                    result = result.replace(reg, args[key]);
                }
            }
        }
        else {
            for (var i = 0; i < arguments.length; i++) {
                if (arguments[i] != undefined) {
                    //var reg = new RegExp("({[" + i + "]})", "g");//这个在索引大于9时会有问题，谢谢何以笙箫的指出
　　　　　　　　　　　　var reg= new RegExp("({)" + i + "(})", "g");
                    result = result.replace(reg, arguments[i]);
                }
            }
        }
    }
    return result;
}